import PySimpleGUIWeb as sg
import subprocess
import os
import os.path
import json
import sys
import time
import logging
from subprocess import call
import threading
import fileinput
import shlex
import signal
import multiprocessing
import gui_kitsune
from watchdog.observers import Observer
from watchdog.events import PatternMatchingEventHandler

adLoop = 0

adPID = 0

#anomaly detection 
class Anomaly(PatternMatchingEventHandler):

    def on_modified(self, event):
        global adLoop
        adLoop +=1
        global adPID
        if adLoop == 1:
            f = open("/home/pi/MQP/IoT-MQP/UI/Kitsune/anomaly_log/log.txt", "r")
            macLines = f.readlines()
            f.close()
            infected = macLines[-1].upper()
            infList = infected.split(",")
            src = infList[0].rstrip()
            dst = infList[1].rstrip()
    
            friendlySRC = friendlyLookup(src)
            friendlyDST = friendlyLookup(dst)
            
            friendlySRC = str(friendlySRC)
            friednlyDST = str(friendlyDST)

            window.FindElement('_anlDect_').Update(text = "Anomaly detected from " + friendlySRC + " to "+ friendlyDST +"!    Degrading to selected Functions!      Click Here to Turn off Degrade Filter", disabled = False )
            window.FindElement('_anlDect_').Update(button_color = ('white','red'))
            cmd = activateSecureFilter()
            try:
                anomalyDetected = subprocess.Popen(shlex.split(cmd), shell = False, stdout = subprocess.PIPE)
                anomalyPID = anomalyDetected.pid
                adPID = anomalyPID
            except:
                pass
            print("degrade on")


#Server Variables
#192.168.0.149  
IP = '192.168.0.149'
Port = 8081
refreshRate = 0.001

train_deg_MAC = ""

##Define Commands##
startFingerPrint = 'sudo systemctl start mqp_finger.service'
stopFingerPrint = 'sudo systemctl stop mqp_finger.service'


#Paths
fingersPath = "/home/pi/MQP/finger/synthesized_json"


#Display Variables
seenIPs = [] #Set to hold unique ips
namedIPs = []
masterMACDict = {}
selectedIP = None #holds string of ip selected from listbox
allDeviceInfo = {} # dictionary to hold info
logInfo = [] # store a log of activities to output
pids = []


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

def runCommand(cmd):
    try:
        sp = subprocess.Popen(shlex.split(cmd), shell = False, stdout = subprocess.PIPE)
        commands.append(sp)
        pids.append(sp.pid)
    except:
        pass

def runBlockingCommand(cmd):
    try:
        sp = subprocess.Popen(shlex.split(cmd), shell = False, stdout = subprocess.PIPE)
        out, err = sp.communicate()
        commands.append(sp)
        pids.append(sp.pid)
        if out:
            print(out.decode("utf-8"))
        if err:
            print(err.decode("utf-8"))
    except:
        out = ''
    return out

def watchdogObserver():

    logFilePath = "/home/pi/MQP/IoT-MQP/UI/Kitsune/anomaly_log/log.txt"
    patternPath = logFilePath.strip()
    patterns = [patternPath]
    event_handler = Anomaly(patterns = patterns)
    observer = Observer()
    observer.schedule(event_handler, path = "/home/pi/MQP/IoT-MQP/UI/Kitsune/anomaly_log/", recursive = True)
    observer.start()

    try:
        while True:
            time.sleep(1)
    except KeyboardInterrupt:
        observer.stop()
    observer.join


#Count JSON files, to check for devices
#checks against previously seen devices, checks new

def buildDictionary():                 #fingersPath
    path, dirs, files = next(os.walk(fingersPath))

    for file in files:
        tempDict = {}
        filtered = {}
        prntList = []

        deviceIP = file[0:17].upper().replace(".",":")
        with open(path+ '/' +file, 'r') as f:
          tempDict = json.load(f)
          
          for key, value in tempDict.items():
            if value != None and value != []:
                if value.items() is not None:
                    for key1, value1 in value.items():
                        if value1 != None and value1 != []:
                            filtered[key1] = value1

        finalDict = {}
        filterw, vals = flatten_dict(filtered, ":")
        for items in vals:
            if isinstance(items, list):
                item = ''.join(str(e) for e in items)
                if item != "None" and item != "" and item.lower() != "true" and item.lower() != "false" and (item.isdigit() == False) and (".000Z" not in item) and ("{" not in item) :
                    finalDict[item] = "PlaceHolder"
            else:
                #check for none, numeric, and true or false.
                item = str(items)
                if item != "None" and item != "" and item.lower() != "true" and item.lower() != "false" and (item.isdigit() == False) and (".000Z" not in item) and ("{" not in item) :
                    finalDict[item] = "PlaceHolder"

        allDeviceInfo[deviceIP] = finalDict


    return allDeviceInfo
#https://codereview.stackexchange.com/questions/173439/pythonic-way-to-flatten-nested-dictionarys
def flatten_dict(dictionary, delimiter=':'):
    """
    Function to flatten a nested dictionary structure
    :param dictionary: A python dict()
    :param delimiter:  The desired delimiter between 'keys'
    :return: dict()
    """
    dictionary_ = dictionary

    def unpack(parent_key, parent_value):
        """
        A function to unpack one level of nesting in a python dictionary
        :param parent_key: The key in the parent dictionary being flattened
        :param parent_value: The value of the parent key, value pair
        :return: list(tuple(,))
        """
        if isinstance(parent_value, dict):
            return [
                (parent_key + delimiter + key, value)
                for key, value
                in parent_value.items()
            ]
        # If the If the parent_value is a not dict leave it be
        else:
            return [ (parent_key, parent_value) ]
    # Keep unpacking the dictionary until all value's are not dictionary's
    allVals = []
    while True:
        # Loop over the dictionary, unpacking one level. Then reduce the dimension one level
        dictionary_ = dict(
            ii
            for i
            in [unpack(key, value) for key, value in dictionary_.items()]
            for ii
            in i )
        # Break when there is no more unpacking to do
        if all([
            not isinstance(value, dict)
            for value
            in dictionary_.values()
        ]):
            for value in dictionary_.values():
 
                allVals.append(value)
            break
    return dictionary_, allVals

def deviceDiscoveryLookup():
                                    #replace with fingersPath
    path, dirs, files = next(os.walk(fingersPath))

    newDevices = []

    for file in files:
        deviceIP = file[0:17].upper().replace(".",":")
        deviceIP.replace(".",":")
        if deviceIP not in seenIPs:
            seenIPs.append(deviceIP)
            namedIPs.append(deviceIP)
            newDevices.append(deviceIP)
            masterMACDict[deviceIP] = deviceIP
    return newDevices


def renameIP(curIpName, reName):

    strippedIP = curIpName[0]
    oldIND = namedIPs.index(strippedIP)
    namedIPs.remove(strippedIP)
    namedIPs.insert(oldIND, reName)
    for key, value in masterMACDict.items():
        if key == strippedIP:
            masterMACDict[strippedIP] = reName
    #update dictionary key
    allDeviceInfo[reName] = allDeviceInfo.pop(strippedIP)
    logInfo.append("renamed " + strippedIP + " to " + reName)

    return namedIPs

def macNameLookup(friendlyName):
    for key, value in masterMACDict.items():
        if value == friendlyName:
            return key

def friendlyLookup(mac):
    try:
        if masterMACDict[mac] != None:
            return masterMACDict[mac]
    except:
        return mac

def trainBaseline(mac):
    #go through all devices seen and call train baseline function
     train_deg_MAC = mac
     
     trainBaselineDevice = "sudo python3 /home/pi/MQP/degradation/create_baseline_set.py --mac " + train_deg_MAC + " --seconds 180"
     #runCommand(trainBaselineDevice) 

def trainFunction(mac, fname, edList):
    train_mac = mac
    train_name = fname
    fname = fname.replace(" ", "_")
     
    edString = ''.join(edList)
    trainFunction = "sudo python3 /home/pi/MQP/degradation/create_training_set.py --mac " + train_mac + " --feature " + fname 
    print(trainFunction)
    window.FindElement("trainHelp").Update("Press 'Enter'to mark the start/stop of function intervals")
    runBlockingCommand(trainFunction)
    
    f = open('/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt', "a+")
    rule = mac.upper().replace(".", ":") + "," + fname + ",accept," + edString
    f.write(rule + "\r\n")
    f.close()
    
    logInfo.append("trained " + fname + " for " + train_mac)
    print("updating models")
    updateModels = "sudo python3 /home/pi/MQP/degradation/update_models.py"
    window.FindElement("trainHelp").Update("Done Training. Updateing Functions, please wait")
    runBlockingCommand(updateModels)
    window.FindElement("trainHelp").Update('')
    logInfo.append("updated training models")
    print("done loading models")

def discoverTrainingSets():
    #OS path walk through devices, looking for files that are not Baseline training
    devicesPath = "/home/pi/MQP/degradation/devices"

    devices = []
    trainSets = []
    devices = os.listdir(path = devicesPath)
    

    for device in devices:
        strdevice = str(device)
        tPath = "/home/pi/MQP/degradation/devices/"+strdevice
        files = os.listdir(path = tPath)
        for fname in files:
            if fname != "baseline":
                trainSets.append(strdevice.upper().replace(".",":") + " "+ fname)

    return trainSets
        
def savetoDegradeFile(trainSet):
    if os.path.isfile("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt"):
        return None
    else:
        allDegradeInfo = []
        for info in trainSet:
            mac, function = info.split(' ',1)
            singleDegrade = mac.upper().replace(".",":")+","+function +",accept"
            allDegradeInfo.append(singleDegrade) 

        f = open("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt", "w+")
        for degradeInst in allDegradeInfo:
            f.write(degradeInst + "\r\n")
        f.close()
        
def activateSecureFilter():
    #opens text file of all degrade rules and runs command to secure_filtering.py
    commandString = "sudo python3 /home/pi/MQP/degradation/secure_filtering.py "
    f = open("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt","r")
    rules = f.readlines()
    f.close()
    macList = set([])
    secureInfo = {}
    for line in rules:
        mac = str(line.split(",", 2)[0])
        macList.add(mac)
        secureInfo[mac] = ''

    for macADDR in macList:
        macstring = ""
        for line2 in rules:
            if macADDR in line2:
                funct = line2.split(",",2)[1].rstrip()
                act = line2.split(",",2)[2].rstrip()
                macstring += "," + funct + "," + act

        commandString += " " + macADDR + macstring
    print(commandString)
    return commandString


def checkCurrentDegrade(mac, funct):
    f = open("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt","r")
    rules = f.readlines()
    f.close()
    for rule in rules:
        if mac in rule and funct in rule:
           status = rule.split(',')[2]
           return status.rstrip()

def blockFunction(mac, funct):
    overwrite = []
    for line in fileinput.input("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt", inplace = True):
        if (mac+","+funct+",accept") in line:
            if line.count(",") == 3:
                newline =  mac+","+funct+",drop,"+ line.split(",",3)[3].rstrip() + "\r\n"
            else:
                newline =  mac+","+funct+",drop\r\n"

        else:
            newline = line
        overwrite.append(newline)
    with open ("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt", 'w') as filetowrite:
        for nline in overwrite:
            filetowrite.write(nline)
        filetowrite.close()
    logInfo.append("blocked "+ funct + " for "+ mac)

def allowFunction(mac, funct):
    overwrite = []
    for line in fileinput.input("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt", inplace = True):
        if (mac+","+funct+",drop") in line:
            if line.count(",") == 3:
                newline =  mac+","+funct+",accept,"+ line.split(",", 3)[3].rstrip() + "\r\n"
            else:
                newline =  mac+","+funct+",accept\r\n"

        else:
            newline = line
        overwrite.append(newline)
    with open ("/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt", 'w') as filetowrite:
        for nline in overwrite:
            filetowrite.write(nline)
        filetowrite.close()
    logInfo.append("allow " + funct + " for " + mac)

def safeCleanup():
    print(len(pids))
    for pid in pids:
        os.system('pkill -TERM -P %s', pid)
        print("killed a pid")



#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

sg.ChangeLookAndFeel('GreenTan')
sg.SetOptions(element_padding=(2,2))


# All the stuff inside your window.

featuretrain = [
                [sg.InputText("Name of Function", size = (24,1), key = ("_tName_"))],
                [sg.Checkbox('On/Off', key = 'cbo')],
                [sg.Checkbox('Record Video',key ='cbrv' )],
                [sg.Checkbox('Record Audio', key = 'cbra')],
                [sg.Button('Train Function', key =('startTrain'))],
                [sg.Text('Training Instructions. Name function, select properties and hit Train Function!', key = ("trainHelp"))]
                ]

layout = [  #Menu buttons/ Text

            [sg.Button('Find Devices', size = (10, 1)), sg.Text('Device Names', size=(11,1)), sg.Text('Device Information',size=(21,1)),  sg.InputText(selectedIP, key= ('dispIP'), size =(20,1)),
                sg.Button('Rename', key = ('_RENAMEIP_'), size = (8, 1)), sg.Text(" ", size = (2,1)), sg.Text('Device Functions for:', size = (15,1)), sg.Text('Device Name',text_color ='white',  size = (38,1), key = ('_FunctionDevice_')), sg.Text('Activity Log')],

            # listbox
            [sg.Text('', size=(1, 1)), sg.Listbox(values={}, enable_events=True, key='_IPs_', size=(20, 10)),
             sg.Listbox(values={}, key='_deviceDetails_', size=(50, 10)), sg.Text("", size=(2, 1)), sg.Column(featuretrain, size = (40,10)),sg.Text("", size = (2,1)), sg.Listbox(values = {}, enable_events = True, key ="_log_", size =(25, 10))],

    #Risk layer
            [sg.Button('Load Functions',key = "_Lfunct_", size = (13, 1)), sg.Text('', size=(8,1)), sg.Text('Risk/Function Explanation',size=(37,1)), sg.Button("ALLOW", key = "dgrdON", size = (6,1)), sg.Button("BLOCK", key = "dgrdOFF", size = (6,1))],
            [sg.Text('', size = (1, 1)), sg.Listbox(values = {}, enable_events=True, key='_Functs_', size=(20, 10)), sg.Listbox(values={}, key='_fDetails_', size=(50, 10)), sg.Text("", size = (2,1)),sg.Button("Activate Secure Filter", key= "degradeSwitch", size = (25,10))],

            [sg.Button('Network Status... No Threats Detected',disabled = True,key = ('_anlDect_'), size = (153, 4))]

    #   end

        ]


# Create the Main Window
window = sg.Window('GDI Security Suite', layout = layout,  web_start_browser='True', web_ip = IP , web_port= Port,
                   web_update_interval= refreshRate, web_multiple_instance='False').Finalize()


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#Window Open
print("Client Connected to GDI SUITE")

runCommand(startFingerPrint)

#ANomaly Startup ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ids = threading.Thread(target = gui_kitsune.runIDS, args = (10,30000,10,15), daemon = True)
ids.start()

adLoop = 0
try:
    anomalyDetection = threading.Thread( target = watchdogObserver, daemon = True)
    anomalyDetection.start()
    
except:
    print("failed to start watchjdog Anomaly Detection")


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dcount = 0
# Event Loop to process "events" and get the "values" of the inputs
while True:

    current_time = 0
    event, values = window.Read(timeout = 10)
    if event in (None, 'Cancel'):   # if user closes window or clicks cancel
        break
#fingerprint    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if event == 'Find Devices':
        newDevices = deviceDiscoveryLookup()
        buildDictionary()
        window.FindElement('_IPs_').Update(values=namedIPs)
        window.Layout(layout).Refresh()
        for mac in namedIPs:
            trainBaseline(mac)
            logEntry = "baseline for " + mac
            logInfo.append(logEntry)
        window.FindElement("_log_").Update(values = logInfo)
        
    if event == "_IPs_":
        selectedIP =  values['_IPs_']
        window.FindElement('dispIP').Update(selectedIP)
        window.Layout(layout).Refresh()
        window.FindElement('_FunctionDevice_').Update(selectedIP)
        window.FindElement('_deviceDetails_').Update(allDeviceInfo[values['_IPs_'][0]])

    if event == '_RENAMEIP_':
        if values['_IPs_'] != [None] and values['dispIP'] != [None]:
            renameIP(values['_IPs_'],values['dispIP'])
            window.FindElement('_IPs_').Update(values=namedIPs)
            window.Layout(layout).Refresh()
            window.FindElement("_log_").Update(values = logInfo)
#degradation            
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if event == '_Lfunct_':
        trainData =  discoverTrainingSets()
        window.FindElement("_Functs_").Update(values = trainData)
        savetoDegradeFile(trainData)
#this will chnage to selecting an itwm in the left
    if event == '_Functs_':
        funct = values['_Functs_']
        mac = funct[0].split(" ")[0]
        funName = funct[0].split(" ")[1]
        status = checkCurrentDegrade(mac, funName)
        
         #takes a status and updates the ui to only allow the option of switching to opposite status
        if status == "accept":
            window.FindElement('dgrdON').Update(disabled = True, button_color = ("white", 'gray'))
            window.FindElement('dgrdOFF').Update(disabled = False, button_color=('white','red'))
        elif status == "drop":
            window.FindElement('dgrdON').Update(disabled = False, button_color = ("white", 'green'))
            window.FindElement('dgrdOFF').Update(disabled = True, button_color=('white','gray'))
        else:
            print("incorrect status recieved")
        window.Layout(layout).Refresh()
        
        #educational section
        #look up in degradeRules file
        f = open('/home/pi/MQP/IoT-MQP/UI/Kitsune/degradeRules.txt', 'r')
        eduDisp = {}
        allFlags = []
        for line in f.readlines():
            if mac in line.split(",",3)[0].rstrip() and funName in line.split(",",3)[1].rstrip():
                if line.count(",") == 3:
                    edData = line.split(",", 3)[3].rstrip()
                else:
                    edData = "PP"
                allFlags.append(edData)
        f.close()

        if "1" in allFlags:
            eduDisp["This function operates basic device states like on or off. Hackers can turn these devices on and off at their choosing. Also functions that control the powering on or off of devices such as lights, or thermostats, may allow hackers to infer when you are home or awake, versus away or asleep"] = ''
            window.FindElement('_fDetails_').Update(text_color = '#d442f5')
        if "2" in allFlags:
            eduDisp["This function records video. Hackers can view camera feeds, and take pictures, activate or deactivate cameras. Again, they can see if you are home or awake, versus away or asleep."] = ''
            window.FindElement('_fDetails_').Update(text_color = '#a80702')
        if "3" in allFlags:
            eduDisp["This Function records audio. Hackers can listen to and record audio files from your device. They may also be able to broadcast their own audio announcements over the speakers whenever they choose."] = ''
            window.FindElement('_fDetails_').Update(text_color = 'a84702')
        if "PP" in allFlags:
            eduDisp["No educational flags set at time of training"] = ''
            window.FindElement('_fDetails_').Update(text_color = 'black')


        
        window.FindElement('_fDetails_').Update(values = eduDisp)

    #allow function
    if event == 'dgrdON':
        funct = values['_Functs_']
        mac = funct[0].split(" ")[0]
        funName = funct[0].split(" ")[1]
        allowFunction(mac, funName)
        window.FindElement('dgrdON').Update(disabled = True, button_color = ("white","gray"))
        window.FindElement('dgrdOFF').Update(disabled = False, button_color = ("white", "red"))
        window.Layout(layout).Refresh()
        window.FindElement("_log_").Update(values = logInfo)


    #Degrade function (block it)
    if event == 'dgrdOFF':
        funct = values['_Functs_']
        mac = funct[0].split(" ")[0]
        funName = funct[0].split(" ")[1]
        blockFunction(mac, funName)
        window.FindElement('dgrdON').Update(disabled = False, button_color = ("white","green"))
        window.FindElement('dgrdOFF').Update(disabled = True, button_color = ("white", "gray"))
        window.Layout(layout).Refresh()
        window.FindElement("_log_").Update(values = logInfo)

    
        #add new train function
    if event == "startTrain":
        window.FindElement('startTrain').Update(disabled = True)
        edList = []
        count = 0
        while count < 1:
            if window.FindElement('cbo').Get() == True:
                edList.append('1')
            if window.FindElement('cbrv').Get() == True:
                edList.append('2')
            if window.FindElement('cbra').Get() == True:
                edList.append('3')
            macName = macNameLookup(values['_IPs_'][0])
            functToTrain = values['_tName_']
            trainFunction(macName, functToTrain,edList)
            count += 1
        window.FindElement("_log_").Update(values = logInfo)
        window.FindElement('startTrain').Update(disabled = False)

#degrade    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if event == 'degradeSwitch':
        degradeProc = []
        if dcount == 0:
            cmd = activateSecureFilter()
            try:
                deg = subprocess.Popen(shlex.split(cmd), shell = False, stdout = subprocess.PIPE)
                dp = deg.pid
                print(dp)
            except:
                pass

                            
            dcount = 1
        
            print("degrade on")
        else:
            #os.system('kill -9 %s' %dp)
            deg.terminate()
            os.system('pkill -TERM -P %s' %dp) 
            cmd = "sudo iptables -t raw -F"
            try:
                deg = subprocess.Popen(shlex.split(cmd), shell = False, stdout = subprocess.PIPE)
            except:
                pass
            
            print("degrade off")
            dcount = 0
    if event == '_anlDect_':
        window.FindElement('_anlDect_').Update(disabled = True, button_color = ('white', 'green'), text = "Network Status... No Threats Detected")
        os.system('pkill -TERM -P %s' %adPID) 
        cmd = "sudo iptables -t raw -F"
        try:
            deg = subprocess.Popen(shlex.split(cmd), shell = False, stdout = subprocess.PIPE)
        except:
            pass  
        adLoop = 0
        print("degrade off")



runCommand(stopFingerPrint)

safeCleanup()

window.Close()




