import create_training_set as ts
from argparse import ArgumentParser
from scapy.all import sniff
from os.path import join
from pickle import dump

_packet_list = []

def receive_packet(packet):
    global _packet_list
    _packet_list.append(packet)

def get_labeled_packet_list():
    labeled_packet_list = []
    global _packet_list
    for packet in _packet_list:
        t = (packet.time, packet, True) # stamp, packet, is_function_associated
        labeled_packet_list.append(t)
    return labeled_packet_list

def main():
    argument_parser = ArgumentParser()
    argument_parser.add_argument('--mac', required=True)
    argument_parser.add_argument('--seconds', required=True)
    arguments = argument_parser.parse_args()
 
    pickle_path = join(ts.get_target_path(arguments.mac, 'baseline'), 'training.set')

    print('Sniff sniff for %s seconds' % arguments.seconds)
    sniff(filter='ether src host %s' % arguments.mac,
            iface='wlan0', timeout=int(arguments.seconds), prn=receive_packet)

    labeled_packet_list = get_labeled_packet_list()
    print(len(labeled_packet_list))
    if len(labeled_packet_list) == 0:
        print('Baseline sample was insufficient, not storing')
        return

    print('Saving baseline training data to %s' % pickle_path)
    dump(labeled_packet_list, open(pickle_path, 'wb'))

main()
