from json import dump
from sys import argv
from re import findall
from os.path import join

P0F_LOG = argv[1]
TARGET_DIR = argv[2]
MAC_ADDRESS = P0F_LOG.split('/')[-1].split('.p0f.log')[0]

def find_os_guesses(contents):
    return findall("[|]os=([^|]+)[|]", contents)

def tally_and_map(findings):
    tallies = {}
    seen = set()
    for finding in findings:
        if finding in seen: continue
        seen.add(finding)
        tallies[finding] = findings.count(finding)
    return tallies

def main():
    mapping = {}
    with open(P0F_LOG) as p0f_log:
        contents = p0f_log.read()
        mapping['os'] = tally_and_map(find_os_guesses(contents))
        target_path = join(TARGET_DIR, "%s%s" % (MAC_ADDRESS, '.p0f.json'))
        with open(target_path, 'w') as target:
            dump(mapping, target)

main()

